-- MejLayout.lua
local NameOfLayout = "noBrainPlus"
local Description
local layerFrame

local debugging = false

local function Layout(mainFrame, cds)

	-- Update()
	-- CreateCastFrame( spellTexture, RTframe, height, width, relwhich, relto )
	-- createLayout()
	-- deleteLayout()

	--RunScript(MoonTime_DB["Layout_noBrain"]["boxtext"])
	RunScript(MoonTime_mynext_start .. MoonTime_DB["Layout_noBrain"][MoonTime_DB["Layout_noBrain"]["rotation"]] .. " end")
	
	
	
	
	local time_newicon = GetTime();
	local oldcast = mynext(cds);
	local newcast;
	local dim;
	
	local isLunar
	local isSolar
	local eclipseDirection
	local eclipsePower
	local MF_CD
	local SunF_CD
	local IS_CD
	local FF_CD

	local MoonTimeNextCastframe
	local MoonTimeEclipseframe
	local MoonTimeMFframe
	local MoonTimeSunFframe
	local MoonTimeFaerieFireframe

	local layerFrame = CreateFrame("Frame", "layerFrame", mainFrame )
	layerFrame:SetHeight( mainFrame:GetHeight() )
	layerFrame:SetWidth( mainFrame:GetWidth() )
	layerFrame:SetPoint("CENTER")
	layerFrame:Hide()
	

local TierListe = {}




local procs
local proclist = {
	137590, -- Metagem
	146046, -- Bindings of Immerseus
	148906, -- Toxic Totem Kardis
	}
local a
local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId
local index, value
local name, texture, tier, column, selected, available
local charges, maxCharges, start, charge_duration
local talentduration
local CD, duration


local xdim = MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"];
local ydim = MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["ydim"];



layerFrame.Update = function()
	Treants_CD = cds:GetTreantsCD()
	function isSolar()
		if EPower > 0 then
			return true
		else
			return false
		end
	end
 
	function isLunar()
		return not isSolar()
	end
	
	eclipseDirection, eclipsePower = cds:GetEclipseDirection()
	MF_CD = cds:GetMoonfireCD()
	SunF_CD = cds:GetSunfireCD()
	FF_CD = cds:GetFaerieFireCD()
	CA_CD = cds:GetCelestialAlignmentCD()
	
	procs = 0;

	for a=1,40 do
		name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitBuff("player",a,"PLAYER")
	
		for index, value in pairs(proclist) do
			if spellId == value then
				procs=procs+1;
			end
		end
	end

	-- MoonTimeNextCastframe
	if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["active"] ) then 
		MoonTimeNextCastframe:Show()
		newcast = mynext(cds)
		
		if oldcast ~= newcast then
			time_newicon = GetTime();
		else
			
		end
	oldcast = newcast


	MoonTimeNextCastframe:SetIcon(newcast)
	
	xdim = MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"]
	ydim = MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"]
	alpha = 1
		
	if MoonTime_DB["Layout_noBrain"]["blinkspells"][newcast] then
	--GetTime-time_newicon -- wenn 0 volle gre
						--	wenn time_descale normale gre
		xdim = xdim * max(MoonTime_DB["Layout_noBrain"]["blink_factor"]*(1-((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5), 1);
		ydim = ydim * max(MoonTime_DB["Layout_noBrain"]["blink_factor"]*(1-((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5), 1);
		alpha = min( 0.75+((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5/2 , 1 )
	end
	
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["noBrainTile_EclipsePower"] then
		if ( eclipsePower > 0 ) then
			MoonTimeNextCastframe:SetText( "|cffffff00".. abs(eclipsePower) .."|r" )
		else
			MoonTimeNextCastframe:SetText( "|cff0088ff".. abs(eclipsePower) .."|r" )
		end 
	end
	
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["glow"] then
		if ( isSolar or isLunar ) then
			ActionButton_ShowOverlayGlow(MoonTimeNextCastframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeNextCastframe:GetGlowFrame());
		end 
	end
	MoonTimeNextCastframe:SetTextHeight(20)

	MoonTimeNextCastframe.texture:SetVertexColor(1,1,1,alpha)
	MoonTimeNextCastframe:SetHeight(ydim)
	MoonTimeNextCastframe:SetWidth(xdim)
	


	
	alpha = 1;
else
	MoonTimeNextCastframe:Hide()
end

-- MoonTimeEclipseframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["active"] ) then
	if ( eclipseDirection == "moon" ) then
		MoonTimeEclipseframe:SetIcon(Solar_icon)
	else
		MoonTimeEclipseframe:SetIcon(Lunar_icon)
	end
	MoonTimeEclipseframe:Show()
	
	if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["appearance"] == "text" ) then
	
		if eclipseDirection == "sun" then
			MoonTimeEclipseframe:SetText( "|cff0088ff".. abs(eclipsePower) .."|r" )
		elseif eclipseDirection == "moon" then
			MoonTimeEclipseframe:SetText( "|cffffff00".. abs(eclipsePower) .."|r" )
		else
			MoonTimeEclipseframe:SetText( "|cffffffff".. abs(eclipsePower) .."|r" )
		end
		MoonTimeEclipseframe:SetTextHeight(7)
		if eclipseDirection == "moon" and eclipsePower>0 then
			MoonTimeEclipseframe:SetTextHeight(10)
			MoonTimeEclipseframe.texture:SetVertexColor(1,1,1,1)
		elseif eclipseDirection == "sun" and eclipsePower<0 then
			MoonTimeEclipseframe:SetTextHeight(10)
			MoonTimeEclipseframe.texture:SetVertexColor(1,1,1,1)
		end
		
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["glow"] then
		if ( isSolar or isLunar ) then
			ActionButton_ShowOverlayGlow(MoonTimeEclipseframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeEclipseframe:GetGlowFrame());
		end 
	end
else
	MoonTimeEclipseframe:Hide()
end



-- MoonTimeMFframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["active"] ) then
	MoonTimeMFframe:SetText( '' )
	MoonTimeMFframe:Show()
	
	if ( MF_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["appearance"] == "text" then
			MoonTimeMFframe:SetText( '|cfff6ffff' .. math.ceil(MF_CD) .. '|r' )
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["appearance"] == "popup" then
			MoonTimeMFframe:Hide()
		else
			MoonTimeMFframe:SetText( ' ' )
		end
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["glow"] then
		if ( MF_CD <= 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeMFframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeMFframe:GetGlowFrame());
		end 
	end
else
	MoonTimeMFframe:Hide()
end	




-- MoonTimeSunFframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["active"] ) then
	MoonTimeSunFframe:SetText( '' )
	MoonTimeSunFframe:Show()
	
	if ( SunF_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["appearance"] == "text" then
			MoonTimeSunFframe:SetText( '|cfff6ffff' .. math.ceil(SunF_CD) .. '|r' )
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["appearance"] == "popup" then
			MoonTimeSunFframe:Hide()
		else
			MoonTimeSunFframe:SetText( ' ' )
		end
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["glow"] then
		if ( SunF_CD <= 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeSunFframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeSunFframe:GetGlowFrame());
		end 
	end
else
	MoonTimeSunFframe:Hide()
end	

		
-- MoonTimeFaerieFireframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["active"] ) then

	MoonTimeFaerieFireframe:SetText( '' )
	MoonTimeFaerieFireframe:Show()
	
	if ( FF_CD > 1.5 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["appearance"] == "text" then
			if FF_CD > 99 then
				MoonTimeFaerieFireframe:SetText( '|cfff6ffff' .. math.ceil(FF_CD/60) .. 'm|r' )
			else
				MoonTimeFaerieFireframe:SetText( '|cfff6ffff' .. math.ceil(FF_CD) .. '|r' )
			end
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["appearance"] == "popup" then
			MoonTimeFaerieFireframe:Hide()
		else
			MoonTimeFaerieFireframe:SetText( ' ' )
		end
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["glow"] then
		if ( FF_CD < 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeFaerieFireframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeFaerieFireframe:GetGlowFrame());
		end 
	end
else
	MoonTimeFaerieFireframe:Hide()
end

-- MoonTimeCelestialAlignmentframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["active"] ) then

	MoonTimeCelestialAlignmentframe:SetText( '' )
	MoonTimeCelestialAlignmentframe:Show()
	
	
	if ( CA_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["appearance"] == "text" then
			if CA_CD > 175 then
				MoonTimeCelestialAlignmentframe:SetText( '|cffffff00' .. string.format('%2.0f',CA_CD-165) .. '|r' )
			elseif CA_CD > 165 then
				MoonTimeCelestialAlignmentframe:SetText( '|cffffff00' .. string.format('%2.1f',CA_CD-165) .. '|r' )
			elseif CA_CD > 99 then
				MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. math.ceil(CA_CD/60) .. 'm|r' )
			elseif CA_CD < 10 then
				MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. string.format('%2.1f',CA_CD) .. '|r' )
			else
				MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. math.ceil(CA_CD) .. '|r' )
			end
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["appearance"] == "popup" then
			MoonTimeCelestialAlignmentframe:Hide()
		else
			MoonTimeCelestialAlignmentframe:SetText( ' ' )
		end
	end
	
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["glow"] then
		if ( CA_CD < 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeCelestialAlignmentframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeCelestialAlignmentframe:GetGlowFrame());
		end 
	end
else
	MoonTimeCelestialAlignmentframe:Hide()
end
	

-- TierFrames	
	
for a = 1, 7, 1 do
	for b = 1,3 do

	_, name, texture, selected, available = GetTalentInfo(a,b,GetActiveSpecGroup())	
	charges, maxCharges, start, charge_duration = GetSpellCharges(name)
	
	talentduration = 0;
	
	if (a-1)*3+b == 11 or (a-1)*3+b == 18 then
		talentduration = 30;
	end
	
	if ( selected and MoonTime_DB["Layout_noBrainShift"][name]["active"] ) then
		CD, duration = cds:GetTalentCD(a,b)

		TierListe[name]:SetText( '' )
		TierListe[name]:Show()
	
		TierListe[name]:SetChargesText( '' )
	
		if charges then
		
			if charges < maxCharges then
				TierListe[name]:SetChargesText( math.ceil(start+charge_duration-GetTime()) )
			end
		
			if (charges == 0 or procs < 2) and charges < maxCharges  then
				TierListe[name]:SetText( charges )
				TierListe[name].texture:SetVertexColor(1,1,1,.5)
			else
				TierListe[name]:SetText( charges )
				TierListe[name].texture:SetVertexColor(1,1,1,1)	
			end
					
		else
			
			if ( CD > 0 ) then
				if MoonTime_DB["Layout_noBrainShift"][name]["appearance"] == "text" then
					if talentduration > 0 and CD > duration-talentduration and CD-duration+talentduration < 10 then
						TierListe[name]:SetText( '|cfff6ff00' .. string.format('%2.1f',CD-duration+talentduration) .. '|r' )
					elseif CD > duration - talentduration then
						TierListe[name]:SetText( '|cfff6ff00' .. string.format('%2.0f',CD-duration+talentduration) .. '|r' )
					elseif CD > 99 then
						TierListe[name]:SetText( '|cfff6ffff' .. math.ceil(CD/60) .. 'm|r' )
					else
						TierListe[name]:SetText( '|cfff6ffff' .. math.ceil(CD) .. '|r' )
					end
				elseif MoonTime_DB["Layout_noBrainShift"][name]["appearance"] == "popup" then
					TierListe[name]:Hide()
				else
					TierListe[name]:SetText( ' ' )
				end
			end
		
		end
		
	if MoonTime_DB["Layout_noBrainShift"][name]["glow"] then
		if ( CD == 0 ) then
			ActionButton_ShowOverlayGlow(TierListe[name]:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(TierListe[name]:GetGlowFrame());
		end 
	end
		
		
		
	else
		TierListe[name]:Hide()
	end
end
end



end	
	
	
	
	
	
	
	
	
	layerFrame.CreateCastFrame = function( spellTexture, RTframe, width, height, relwhich, relto, xoff, yoff )
		if not xoff then xoff= 0 end
		if not yoff then yoff= 0 end

		
		
		local frame = CreateFrame( "Frame", "MTCastframe"..RTframe:GetName(), layerFrame )
		frame:SetHeight(height)
		frame:SetWidth(width)
		frame:SetPoint(relwhich, RTframe, relto, xoff, yoff)
		
		frame.texture = frame:CreateTexture("CastFrameTexture")

		frame.texture:SetTexture(spellTexture);
		frame.texture:SetAllPoints()
		
		local glowframe = CreateFrame( "Frame", "MTGlowframe", frame )
		glowframe:SetHeight(height+8)
		glowframe:SetWidth(width+8)
		glowframe:SetPoint("CENTER", frame, "CENTER", 0, 0)
		
		frame.GetGlowFrame = function ( self )
			return glowframe
		end

		local labelframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		labelframe:SetTextColor( 1, 1, 1, 1 );

		
		-- find a good textheight
		local textheight = min(height,24);
		labelframe:SetFont("Fonts\\FRIZQT__.TTF", textheight, "THICKOUTLINE")
		
		if width < 36 then
			labelframe:SetText("10")
		else
			labelframe:SetText("8m")
		end

		
		while labelframe:GetStringWidth()-2 > frame:GetWidth() and textheight>2 do
			textheight = textheight-1;
			labelframe:SetFont("Fonts\\FRIZQT__.TTF", textheight, "THICKOUTLINE")
		end	
	
		labelframe:SetPoint("CENTER", frame, "CENTER",2,-floor(textheight/10+.5))--ceil(labelframe:GetWidth()-frame:GetWidth())/2,-1)
	

		labelframe:SetText("")
		local h
		
		frame.SetText = function( self, msg )
			if( msg == '' ) then
				self.texture:SetVertexColor(1,1,1,1)		
			else
				self.texture:SetVertexColor(1,1,1,.5)	
			end
			
			
			-- find the correct textheight
			h = textheight
			
			labelframe:SetText(msg)
			while labelframe:GetStringWidth()-2 > self:GetWidth() and h>2 do
				h = h-1;
				labelframe:SetFont("Fonts\\FRIZQT__.TTF", h, "THICKOUTLINE")
			end		
		end
		
		local chargesframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		chargesframe:SetPoint("TOPLEFT", frame, "TOPLEFT")
		chargesframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT",0,0)
		chargesframe:SetTextColor( .8, .8, .8, 1 );
		chargesframe:SetJustifyH("RIGHT")
		chargesframe:SetJustifyV("BOTTOM")
		

	
		frame.SetChargesText = function( self, msg )
			chargesframe:SetText(msg)

			-- find the correct textheight
			h = 8;
			--while chargesframe:GetStringWidth() > self:GetWidth()/2 and h>1 do
--				chargesframe:SetFont("Fonts\\FRIZQT__.TTF", h, "OUTLINE")
				--h = h-1;					
			--end
		end
		
		
		frame.SetTextHeight = function( self, height )
			labelframe:SetFont("Fonts\\FRIZQT__.TTF", height, "THICKOUTLINE")
			
	
			while height>0 and labelframe:GetStringWidth() > labelframe:GetWidth() do
				labelframe:SetFont("Fonts\\FRIZQT__.TTF", height, "THICKOUTLINE")
				height= height-1;
			end
			labelframe:SetPoint("CENTER", frame, "CENTER",2,-floor(height/10+.5))
		end
		
		frame.SetJustifyH = function( self, H )
			labelframe:SetJustifyH(H);
		end
		
		frame.SetJustifyV = function( self, V )
			labelframe:SetJustifyV(V);
		end			

		frame.SetIcon = function( self, icon )
			self.texture:SetTexture(icon)
		end
		
		return frame
	end

	layerFrame.createLayout = function ()
		MoonTimeMFframe = layerFrame.CreateCastFrame( MF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["yoffset"])
		MoonTimeSunFframe = layerFrame.CreateCastFrame( SunF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["yoffset"])
		MoonTimeFaerieFireframe = layerFrame.CreateCastFrame( FF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["yoffset"])
		MoonTimeEclipseframe = layerFrame.CreateCastFrame( "", layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["yoffset"])
		MoonTimeNextCastframe = layerFrame.CreateCastFrame( "", layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["yoffset"])
		MoonTimeCelestialAlignmentframe = layerFrame.CreateCastFrame( CA_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["yoffset"])
		
		for a = 1, 7, 1 do
			for b = 1, 3 do 
				local _, name, texture = GetTalentInfo(a, b, 1, nil, nil, 11)	
				TierListe[name] = layerFrame.CreateCastFrame( texture, layerFrame, MoonTime_DB["Layout_noBrainShift"][name]["xdim"], MoonTime_DB["Layout_noBrainShift"][name]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"][name]["xoffset"],MoonTime_DB["Layout_noBrainShift"][name]["yoffset"])
			end
		end
end	

	layerFrame.deleteLayout = function()
		MoonTimeNextCastframe:Hide()
		MoonTimeNextCastframe = nil
		MoonTimeEclipseframe:Hide()
		MoonTimeEclipseframe = nil
		MoonTimeMFframe:Hide()
		MoonTimeMFframe = nil
		MoonTimeSunFframe:Hide()
		MoonTimeSunFframe = nil
		MoonTimeFaerieFireframe:Hide()
		MoonTimeFaerieFireframe = nil
		MoonTimeCelestialAlignmentframe:Hide()
		MoonTimeCelestialAlignmentframe = nil
		
		for a = 1, 7, 1 do
			for b = 1, 3 do
				local _, name, texture = GetTalentInfo(a, b, 1)		
				TierListe[name]:Hide()
				TierListe[name] = nil
			end
		end
		
		layerFrame:Hide()
		layerFrame = nil
	end
	


	return layerFrame
end

-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerLayout( name )									-- Beginn initialize
	local LayoutFrame
	local frame = CreateFrame( "Frame", name, UIPARENT	)
	frame.ID = name
	frame:RegisterEvent("VARIABLES_LOADED");
	
	

	frame:SetScript("OnEvent", 
		function( self, event )

			if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
																		-- werden die ausstehenden Events registriert
				if ( GetLocale() == "deDE" ) then
					frame.description = MoonTime_noBrainShift_Strings["deDE"]["description"]
				else
					frame.description = MoonTime_noBrainShift_Strings["enGB"]["description"]
				end
				
				frame:SetScript("OnUpdate", function(self, event, ... ) 		
					name = GetTalentInfo(7,1, 1, nil, nil, 11);
		
				if name then
					frame:SetScript("OnUpdate",nil)
					MoonTimeDoorKeeper:RegisterLayout( self );
				end 
		
			end)
		end
	end)

	
	frame.createLayout = function( self ) 
		LayoutFrame = Layout(self.Mainframe, self.Objectframe)
		LayoutFrame:createLayout()
	end

	frame.Hide = function()
		--print("hide()")
		LayoutFrame:Hide()
	end
	frame.Show = function()
		--print("show()")
		LayoutFrame:Show()
	end
	frame.Update = function()
		LayoutFrame:Update()
	end

	frame.deleteLayout = function()
		LayoutFrame:deleteLayout()
	end
	

	
end																		-- Ende initialize

registerLayout(NameOfLayout)